<template>
  <div class="content-block">
    <div class="container">
      <div class="margin-top-50"></div>
      <div class="row">
        <div class="columns twelve">
          <div class="content">
            <h3 class="main-header">Изменение пароля</h3>
            <div class="white-block">
              <div class=" padding">
                <form @submit.prevent="changePassword">
                  <div class="row">
                    <label for="password">Текущий пароль:</label>
                    <input
                      v-model="currentPassword"
                      type="password"
                      name="Текущий пароль"
                      id="current-password"
                      v-validate="'required'"
                      :class="getValidateClass('Текущий пароль')"
                    />
                    <validate-message
                      v-show="vErrors.has('Текущий пароль')"
                    >{{ vErrors.first('Текущий пароль') }}
                    </validate-message>
                  </div>
                  <div class="row">
                    <div class="columns six">
                      <label for="password">Новый пароль:</label>
                      <input
                        v-model="password"
                        type="password"
                        name="Пароль"
                        id="password"
                        v-validate="'required'"
                        :class="getValidateClass('Пароль')"
                      />
                      <validate-message
                        v-show="vErrors.has('Пароль')"
                      >{{ vErrors.first('Пароль') }}
                      </validate-message>
                    </div>
                    <div class="columns six">
                      <label for="password2">Повтор нового пароля:</label>
                      <input
                        v-model="passwordAgain"
                        type="password"
                        name="Пароль"
                        id="password2"
                        v-validate="'required'"
                        :class="getValidateClass('Пароль')"
                      />
                      <validate-message
                        v-show="vErrors.has('Пароль')"
                      >{{ vErrors.first('Пароль') }}
                      </validate-message>
                    </div>
                  </div>
                  <div class="row">
                    <div class="warning-block">
                      Внимание, пароль должен содержать минимум 7 символов, включающих: цифры, БОЛЬШИЕ и маленькие латинские буквы.
                    </div>
                  </div>
                  <div class="row">
                    <button type="submit">Изменить пароль</button>
                  </div>
                </form>
              </div>
              <vuex-error-block :errors-fields="['mainErrorBlock']" style="display: none"></vuex-error-block>
              <success-message></success-message>
              <warning-message></warning-message>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
  import GetValidateClass from '@/mixins/Validation/GetValidateClassMixin'
  // import {changePassword} from '@/utils/api'
  import backendApi from '@/utils/backend-api'
  import ErrorHandleMixin from '@/mixins/ErrorHandleMixin'
  import SuccessMessage from '@/components/AuxiliaryWindows/SuccessMessage'
  import WarningMessage from '@/components/AuxiliaryWindows/WarningMessage'
  import {errorChangePassport} from '@/utils/error/change-passport'

export default {
    name: 'ChangePassword',
    mixins: [GetValidateClass, ErrorHandleMixin],
    data () {
      return {
        flag: false,
        currentPassword: '',
        password: '',
        passwordAgain: ''
      }
    },
    computed: {
      isPasswordsSame () {
        return this.password === this.passwordAgain
      }
    },
    components: {
      SuccessMessage,
      WarningMessage,
    },
    methods: {
      async changePassword () {
        await this.$validator.validateAll().then((e) => {
          console.log('то что поступило', e)
          this.flag = e
          if (!e) {
            this.$store.commit('CALL_WARNING_WINDOW', 'Заполните обязательные поля')
          }
        })
        if (!this.isPasswordsSame) {
          let message = 'Пароли не совпадают'
          this.$store.commit('SET_ERRORS', [{field: 'Пароль', message: message}])
          this.$store.commit('CALL_WARNING_WINDOW', message)
        }
        console.log('Itog', this.flag)
        if (this.flag && this.isPasswordsSame) {
          this.postDataByChangePassword()
        }
      },
      postDataByChangePassword () {
        this.$backend.api.user.password.change({
          password: this.password,
          oldPassword: this.currentPassword
        })
          .then(() => {
            this.currentPassword = this.password = this.passwordAgain = ''
            this.$store.commit('CALL_SUCCESS_WINDOW', 'Пароль успешно изменён')
            this.vErrors.items = ''
          })
          .catch((err) => {
            errorChangePassport(err.errors[0].code, this.$store)
          })
      }
    }
  }
</script>

<style scoped lang="scss">
  .white {
    cursor: default;
    color: #b4cadd;
    background: #fff;
  }

  .white:hover {
    background: #fff;
  }

  .warning-block {
    background: none;
    padding-left: 30px;
  }
</style>
